Subject: recovering a corrupted git repo

From: Phillip Susi <[email-masked]>
Date: Sun, 06 Jan 2013 22:44:58 -0500

I have not had any issue until I ran a git fsck recently, which
repored gzip and crc errors in some pack files.  git fsck does not
seem to repair the errors, only report them.  I would like to try to
rebuild my repository, without downloading any more from the origin
than I have to.  All of the commits I have added seem to still be
intact, so I assume the corruption in somewhere in the upstream
history packs.

How can I correct the errors, and fetch the corrupted upstream
history, while preserving my patches?  So far I have exported my
patches as bundles, and made a fresh clone from upstream, then pulled
the bundles back in, but there must be a better way that only fetches
the corrupted bits from upstream?